#ifndef __primitives_h
#define __primitives_h

#define AMBIENT 0
#define DIFFUSE 1
#define SPECULAR 2

typedef struct {
  tPoint center;
  double radius;
  double ambientIntensity;
  tVector diffuseColor,specularColor,emissiveColor;
  tVector reflection;
  double reflectionexponent,refractionindex,transparency;
} tSphere;

typedef struct {
  tPoint vertex[3];
  tVector normal[3];
  double ambientIntensity;
  tVector diffuseColor,specularColor,emissiveColor;
  tVector reflection;
  double reflectionexponent,refractionindex,transparency;
} tTriangle;

typedef struct {
  tPoint location;
  tVector direction,right,up;
  double angle;
} tCamera;

typedef struct {
  tPoint location;
  tVector direction,color;
  double cosangle, cosfalloff;
  tVector attenuation;
} tPointLight;

#endif
