#include "controls.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qstring.h>

#define EPS 0.0000001

Controls::Controls( QWidget* parent, const char* name) : QWidget( parent, name )
{
   QButton *loadVRMLButton = new QPushButton("Importuj VRML", this, "MyButton");
   QButton *loadSceneButton = new QPushButton("Nacitaj .scene", this, "MyButton");
   QButton *saveSceneButton = new QPushButton("Uloz .scene", this, "MyButton");

   QButton *changeCameraLocation = new QPushButton("zmen polohu kamery", this, "MyButton");
   QButton *changeCameraLookAt = new QPushButton("zmen lookat kamery", this, "MyButton");
   QButton *changeCameraUp = new QPushButton("zmen up kamery", this, "MyButton");

   QButton *raytraceButton = new QPushButton("RAYTRACE", this, "MyButton");
   QButton *quitButton = new QPushButton("Skonci", this, "MyButton");

   QButton *addAmbientLightButton = new QPushButton("Pridaj ambient", this, "MyButton");
   QButton *addPointLightButton = new QPushButton("Pridaj point", this, "MyButton");
   QButton *addSpotLightButton = new QPushButton("Pridaj spot", this, "MyButton");
   QButton *changeLightColorButton = new QPushButton("Zmen farbu", this, "MyButton");
   QButton *changeLightLocationButton = new QPushButton("Zmen polohu", this, "MyButton");
   QButton *changeLightLookAtButton = new QPushButton("Zmen kam svieti", this, "MyButton");
   QButton *changeLightAngleButton = new QPushButton("Zmen uhol", this, "MyButton");
   QButton *deleteLightButton = new QPushButton("Zmaz", this, "MyButton");

//   QButton *addTriangleButton = new QPushButton("Pridaj", this, "MyButton");
   QButton *deleteTriangleButton = new QPushButton("Zmaz", this, "MyButton");
   
//   QButton *addSphereButton = new QPushButton("Pridaj", this, "MyButton");
//   QButton *changeSphereCenterButton = new QPushButton("Zmen stred", this, "MyButton");
//   QButton *changeSphereRadiusButton = new QPushButton("Zmen polomer", this, "MyButton");
   QButton *deleteSphereButton = new QPushButton("Zmaz", this, "MyButton");
   
   lightList = new QListBox(this);
   triangleList = new QListBox(this);
   triangleList->setSelectionMode(QListBox::Extended);
   sphereList = new QListBox(this);
   sphereList->setSelectionMode(QListBox::Extended);

   lightPokec = new QLabel(this);
   trianglePokec = new QLabel(this);
   spherePokec = new QLabel(this);
   cameraPokec = new QLabel(this);

   QGridLayout *mainGrid = new QGridLayout(this,1,7,10);
   
   QVBoxLayout *toolbarGrid = new QVBoxLayout;    mainGrid->addLayout(toolbarGrid,0,0);
   QVBoxLayout *lightListGrid = new QVBoxLayout;  mainGrid->addLayout(lightListGrid,0,1);
   QVBoxLayout *lightGrid = new QVBoxLayout;      mainGrid->addLayout(lightGrid,0,2);
   QVBoxLayout *triListGrid = new QVBoxLayout;    mainGrid->addLayout(triListGrid,0,3);
   QVBoxLayout *triGrid = new QVBoxLayout;        mainGrid->addLayout(triGrid,0,4);
   QVBoxLayout *sphereListGrid = new QVBoxLayout;    mainGrid->addLayout(sphereListGrid,0,5);
   QVBoxLayout *sphereGrid = new QVBoxLayout;        mainGrid->addLayout(sphereGrid,0,6);

   toolbarGrid->addWidget(loadVRMLButton);   
   toolbarGrid->addWidget(loadSceneButton);   
   toolbarGrid->addWidget(saveSceneButton);   
   
   toolbarGrid->addWidget(cameraPokec);
   toolbarGrid->addWidget(changeCameraLocation);
   toolbarGrid->addWidget(changeCameraLookAt);
   toolbarGrid->addWidget(changeCameraUp);
   
   toolbarGrid->addWidget(raytraceButton);   
   toolbarGrid->addWidget(quitButton);

   lightListGrid->addWidget(new QLabel("<b>Zoznam svetiel:</b>",this));
   lightListGrid->addWidget(lightList);
   lightListGrid->addWidget(lightPokec);
   
   lightGrid->addWidget(new QLabel("<b>Svetla:</b>",this));
   lightGrid->addWidget(addAmbientLightButton);
   lightGrid->addWidget(addPointLightButton);
   lightGrid->addWidget(addSpotLightButton);
   lightGrid->addWidget(changeLightColorButton);
   lightGrid->addWidget(changeLightLocationButton);
   lightGrid->addWidget(changeLightLookAtButton);
   lightGrid->addWidget(changeLightAngleButton);
   lightGrid->addWidget(deleteLightButton);
   lightGrid->insertStretch(-1,10);
   
   triListGrid->addWidget(new QLabel("<b>Zoznam trojuh.:</b>",this));
   triListGrid->addWidget(triangleList);
   triListGrid->addWidget(trianglePokec);

   triGrid->addWidget(new QLabel("<b>Trojuholniky:</b>",this));
//   triGrid->addWidget(addTriangleButton);
   triGrid->addWidget(deleteTriangleButton);
   triGrid->insertStretch(-1,10);
   
   sphereListGrid->addWidget(new QLabel("<b>Zoznam guli:</b>",this));
   sphereListGrid->addWidget(sphereList);
   sphereListGrid->addWidget(spherePokec);

   sphereGrid->addWidget(new QLabel("<b>Gule:</b>",this));
//   sphereGrid->addWidget(addSphereButton);
//   sphereGrid->addWidget(changeSphereCenterButton);
//   sphereGrid->addWidget(changeSphereRadiusButton);
   sphereGrid->addWidget(deleteSphereButton);
   sphereGrid->insertStretch(-1,10);
   
   connect(loadVRMLButton, SIGNAL(clicked()), this, SLOT(loadVRMLSLOT()));
   connect(loadSceneButton, SIGNAL(clicked()), this, SLOT(loadSceneSLOT()));
   connect(saveSceneButton, SIGNAL(clicked()), this, SLOT(saveSceneSLOT()));
  
   connect(changeCameraLocation, SIGNAL(clicked()), this, SLOT(changeCameraLocationSLOT()));
   connect(changeCameraLookAt, SIGNAL(clicked()), this, SLOT(changeCameraLookAtSLOT()));
   connect(changeCameraUp, SIGNAL(clicked()), this, SLOT(changeCameraUpSLOT()));
   
   connect(raytraceButton, SIGNAL(clicked()), this, SLOT(raytraceSLOT()));
   connect(quitButton, SIGNAL(clicked()), this, SLOT(quitButtonPushedSLOT()));

   connect(addAmbientLightButton, SIGNAL(clicked()), this, SLOT(addAmbientLightSLOT()));
   connect(addPointLightButton, SIGNAL(clicked()), this, SLOT(addPointLightSLOT()));
   connect(addSpotLightButton, SIGNAL(clicked()), this, SLOT(addSpotLightSLOT()));
   connect(changeLightColorButton, SIGNAL(clicked()), this, SLOT(changeLightColorSLOT()));
   connect(changeLightLocationButton, SIGNAL(clicked()), this, SLOT(changeLightLocationSLOT()));
   connect(changeLightLookAtButton, SIGNAL(clicked()), this, SLOT(changeLightLookAtSLOT()));
   connect(changeLightAngleButton, SIGNAL(clicked()), this, SLOT(changeLightAngleSLOT()));
   connect(deleteLightButton, SIGNAL(clicked()), this, SLOT(deleteLightSLOT()));
   
   connect(lightList,SIGNAL(selectionChanged()),this,SLOT(describeLightSLOT()));
   connect(triangleList,SIGNAL(selectionChanged()),this,SLOT(describeTriangleSLOT()));
   connect(sphereList,SIGNAL(selectionChanged()),this,SLOT(describeSphereSLOT()));

   connect(deleteTriangleButton, SIGNAL(clicked()), this, SLOT(deleteTriangleSLOT()));
   
   connect(deleteSphereButton, SIGNAL(clicked()), this, SLOT(deleteSphereSLOT()));
   
   Kamera.location[0]=Kamera.location[1]=Kamera.location[2]=0; Kamera.location[3]=1;
   Kamera.direction[2]=1; Kamera.direction[0]=Kamera.direction[1]=Kamera.direction[3]=0;
   Kamera.right[0]=0.3*1.33333333; Kamera.right[1]=Kamera.right[2]=Kamera.right[3]=0;
   Kamera.up[1]=0.3*1; Kamera.up[0]=Kamera.up[2]=Kamera.up[3]=0;
   
   lightPokec->setText(QString("Tu bude pokec\no svetle"));
   trianglePokec->setText(QString("Tu bude pokec\no trojuholniku"));
   spherePokec->setText(QString("Tu bude pokec\no guli"));
   describeCameraSLOT();
}

Controls::~Controls()
{
}

double DotProduct(tVector v1, tVector v2) { return (v1[0]*v2[0] + v1[1]*v2[1] + v1[2]*v2[2]); }
double Length(tVector v1) { return sqrt(DotProduct(v1,v1)); }
void Normalize(tVector *v1) {int i;double l;l=Length(*v1);if(l<EPS)return; for (i=0;i<3;i++) (*v1)[i]/=l; (*v1)[3]=0; }
void CrossProduct(tVector v1, tVector v2, tVector *res) {
  (*res)[0]=v1[1]*v2[2]-v1[2]*v2[1]; (*res)[1]=v1[2]*v2[0]-v1[0]*v2[2];
  (*res)[2]=v1[0]*v2[1]-v1[1]*v2[0]; (*res)[3]=0; return;
}

//void Controls::myButtonPushedSLOT() { printf("MyButton:  I've been clicked!\n"); emit rotateSIGNAL(); }

void Controls::quitButtonPushedSLOT() { emit dieSIGNAL(); }

void Controls::raytraceSLOT()
{
  bool ok;
  QString qparams = QInputDialog::getText("mfray-gui","Parametre pre raytracer:",QLineEdit::Normal,
     "-x400 -y300 -depth3",&ok,this);
  if (!ok) return;
    
  QString qpom;
  char *params[100];
  int poc=2;
  params[0]=(char *)malloc(20); strcpy(params[0],"mfray");
  params[1]=(char *)malloc(20); strcpy(params[1],"ph0ur71-53v3n.scene");
  while (1) {
    qpom = qparams.section(' ',poc-2,poc-2,QString::SectionSkipEmpty);
    if (qpom.isEmpty()) break;
    params[poc]=(char *)malloc(qpom.length()+10); strcpy(params[poc],qpom.latin1()); 
    poc++;
  }
  params[poc]=NULL;
//  for (int i=0;i<poc;i++) printf("'%s'\n",params[i]);
  
  SaveScene("ph0ur71-53v3n.scene");
  if (fork()==0) {
    execv("bin/mfray",params);
  } else {
//    PleaseWait *myPleaseWait=new PleaseWait(0,"mfray-gui");
//    myPleaseWait->show();
    hide();
//    QMessageBox::information(this,"mfray-gui","Pockajte prosim, kym raytracovanie skonci.");
    wait(NULL);
//    myPleaseWait->hide();
    show();
  }
  for (int i=0;i<poc;i++) free(params[i]);
  remove("ph0ur71-53v3n.scene");
}

////////////////////////////////////////////////////////////////////////////////
//                      zmeny kamery 
////////////////////////////////////////////////////////////////////////////////

void Controls::changeCameraLocationSLOT() 
{
  double X,Y,Z;
  QString def("");
    def += QString::number(Kamera.location[0]);
    def += QString(" ");
    def += QString::number(Kamera.location[1]);
    def += QString(" ");
    def += QString::number(Kamera.location[2]);

  int result = getDoubleVector("Zadaj suradnice kamery oddelene medzerami",def,&X,&Y,&Z);
  if (result) { 
    Kamera.location[0]=X; Kamera.location[1]=Y; Kamera.location[2]=Z; 
    // FIXME spocitat up
  }
  describeCameraSLOT();
  emit repaintSIGNAL();
}

void Controls::changeCameraLookAtSLOT() 
{
  double X,Y,Z,pom;
  tVector perp;
  QString def("");
    def += QString::number(Kamera.location[0]+Kamera.direction[0]);
    def += QString(" ");
    def += QString::number(Kamera.location[1]+Kamera.direction[1]);
    def += QString(" ");
    def += QString::number(Kamera.location[2]+Kamera.direction[2]);

  int result = getDoubleVector("Zadaj suradnice kam kamera pozera oddelene medzerami",def,&X,&Y,&Z);
  if (result) { 
    Kamera.direction[0]=X; Kamera.direction[1]=Y; Kamera.direction[2]=Z;
    for (int i=0;i<3;i++) Kamera.direction[i]-=Kamera.location[i];
        perp[1]=0;
        if (Length(perp)<EPS){
          // pozerame hore alebo dole
        } else {
          pom=perp[0]; perp[0]=perp[2]; perp[2]=-pom; // note the minus sign!
          CrossProduct(Kamera.direction,perp,&Kamera.up); Normalize(&Kamera.up);
          CrossProduct(Kamera.up,Kamera.direction,&Kamera.right);
          for (int j=0;j<3;j++) { 
            Kamera.up[j]*=0.3*Length(Kamera.direction);
            Kamera.right[j]*=0.4*Length(Kamera.direction);
          }
        }
  }
  describeCameraSLOT();
  emit repaintSIGNAL();
}

void Controls::changeCameraUpSLOT() 
{
  double X,Y,Z;
  int i;
  
  QString def("");
    def += QString::number(Kamera.up[0]);
    def += QString(" ");
    def += QString::number(Kamera.up[1]);
    def += QString(" ");
    def += QString::number(Kamera.up[2]);
  int result = getDoubleVector("Zadaj vektor kamera-up",def,&X,&Y,&Z);
  if (result) { 
    Kamera.up[0]=X; Kamera.up[1]=Y; Kamera.up[2]=Z;

          CrossProduct(Kamera.up,Kamera.direction,&Kamera.right);
          Normalize(&Kamera.right);
          for (i=0;i<3;i++) Kamera.right[i]*=4/3.0*Length(Kamera.up);
  }
  
  describeCameraSLOT();
  emit repaintSIGNAL();
}

////////////////////////////////////////////////////////////////////////////////
//                      zmeny svetiel
////////////////////////////////////////////////////////////////////////////////

void Controls::changeLightColorSLOT() 
{
  int kolko;
  if (lightList->currentItem()==-1) return;
  sscanf(lightList->currentText().latin1(),"Light %d",&kolko);
  QColor farba = QColorDialog::getColor(lights[kolko].color);
  if (!farba.isValid()) return; 
  lights[kolko].color=farba;
  describeLightSLOT();
  emit repaintSIGNAL();
}

void Controls::changeLightLocationSLOT() 
{
  int kolko;
  if (lightList->currentItem()==-1) return;
  sscanf(lightList->currentText().latin1(),"Light %d",&kolko);
  if (lights[kolko].type==AMBIENT) return; 
  double X,Y,Z;
  QString def("");
    def += QString::number(lights[kolko].location[0]);
    def += QString(" ");
    def += QString::number(lights[kolko].location[1]);
    def += QString(" ");
    def += QString::number(lights[kolko].location[2]);

  int result = getDoubleVector("Zadaj suradnice svetla oddelene medzerami",def,&X,&Y,&Z);
  if (result) { lights[kolko].location[0]=X; lights[kolko].location[1]=Y; lights[kolko].location[2]=Z; }
  describeLightSLOT();
  emit repaintSIGNAL();
}

void Controls::changeLightLookAtSLOT() 
{
  int kolko;
  if (lightList->currentItem()==-1) return;
  sscanf(lightList->currentText().latin1(),"Light %d",&kolko);
  if (lights[kolko].type==AMBIENT) return; 
  double X,Y,Z;
  QString def("");
    def += QString::number(lights[kolko].location[0]+lights[kolko].direction[0]);
    def += QString(" ");
    def += QString::number(lights[kolko].location[1]+lights[kolko].direction[1]);
    def += QString(" ");
    def += QString::number(lights[kolko].location[2]+lights[kolko].direction[2]);

  int result = getDoubleVector("Zadaj suradnice kam svetlo svieti oddelene medzerami",def,&X,&Y,&Z);
  if (result) { 
    lights[kolko].direction[0]=X; lights[kolko].direction[1]=Y; lights[kolko].direction[2]=Z;
    for (int i=0;i<3;i++) lights[kolko].direction[i]-=lights[kolko].location[i];
  }
  describeLightSLOT();
  emit repaintSIGNAL();
}

void Controls::changeLightAngleSLOT() 
{
  int kolko;
  if (lightList->currentItem()==-1) return;
  sscanf(lightList->currentText().latin1(),"Light %d",&kolko);
  if (lights[kolko].type!=SPOT) return; 
  double X;
  int result = getDouble("Zadaj uhol kuzelu svetla (v stupnoch)",QString::number(lights[kolko].angle),&X);
  if (result) lights[kolko].angle=X;
  result = getDouble("Zadaj uhol kuzelu rozptyl. svetla (v stupnoch)",QString::number(lights[kolko].angle),&X);
  if (result) lights[kolko].falloff=X;
  describeLightSLOT();
  emit repaintSIGNAL();
}

void Controls::deleteLightSLOT() 
{
  int kolko;
  if (lightList->currentItem()==-1) return;
  sscanf(lightList->currentText().latin1(),"Light %d",&kolko);
  lights[kolko].deleted=1;
  lightList->removeItem(lightList->currentItem());
  describeLightSLOT();
  emit repaintSIGNAL();
}

void Controls::deleteTriangleSLOT() 
{
  int k2;
  for (int kolko=triangleList->count()-1;kolko>=0;kolko--) if (triangleList->isSelected(kolko)) {
    sscanf(triangleList->text(kolko).latin1(),"Triangle %d",&k2);
    triangles[k2].deleted=1;
    triangleList->removeItem(kolko);
  }
  describeTriangleSLOT();
  emit repaintSIGNAL();
}

void Controls::deleteSphereSLOT() 
{
  int k2;
  for (int kolko=sphereList->count()-1;kolko>=0;kolko--) if (sphereList->isSelected(kolko)) {
    sscanf(sphereList->text(kolko).latin1(),"Sphere %d",&k2);
    spheres[k2].deleted=1;
    sphereList->removeItem(kolko);
  }
  describeSphereSLOT();
  emit repaintSIGNAL();
}

void Controls::addAmbientLightSLOT() { addLight(AMBIENT); }
void Controls::addPointLightSLOT()   { addLight(POINT); }
void Controls::addSpotLightSLOT()    { addLight(SPOT); }

void Controls::addLight(int typ)
{
  lights[lightCount].type=typ;
  lights[lightCount].color=QColor("white");
  for (int i=0;i<3;i++) { lights[lightCount].location[i]=0; lights[lightCount].direction[i]=i; }
  lights[lightCount].angle=30;
  lights[lightCount].falloff=50;
  lights[lightCount].deleted=0;
  QString s;
  switch (typ) {
    case AMBIENT: s=QString(" (ambient)"); break;
    case POINT: s=QString(" (point)");     break;
    case SPOT: s=QString(" (spot)");       break;
  }
  lightList->insertItem(QString::fromLatin1("Light ")+QString::number(lightCount)+s);
  lightCount++;
  describeLightSLOT();
  emit repaintSIGNAL();
}

void Controls::describeCameraSLOT()
{
  QString s("Kamera:\n");
  s+=QString("poloha: ");
    s+=QString::number(Kamera.location[0],'g',2);
    s+=QString(" ");
    s+=QString::number(Kamera.location[1],'g',2);
    s+=QString(" ");
    s+=QString::number(Kamera.location[2],'g',2);
    s+=QString("\n");
  s+=QString("pozera na: ");
    s+=QString::number(Kamera.location[0]+Kamera.direction[0],'g',2);
    s+=QString(" ");
    s+=QString::number(Kamera.location[1]+Kamera.direction[1],'g',2);
    s+=QString(" ");
    s+=QString::number(Kamera.location[2]+Kamera.direction[2],'g',2);
    s+=QString("\n");
  s+=QString("hore: ");
    s+=QString::number(Kamera.up[0],'g',2);
    s+=QString(" ");
    s+=QString::number(Kamera.up[1],'g',2);
    s+=QString(" ");
    s+=QString::number(Kamera.up[2],'g',2);
    s+=QString("\n");
  cameraPokec->setText(s);
}

void Controls::describeLightSLOT()
{
  lightPokec->setText(QString("Tu bude pokec\no svetle"));

  int kolko;
  if (lightList->currentItem()==-1) return;
  sscanf(lightList->currentText().latin1(),"Light %d",&kolko);
  
  QString s("");
  s+=QString("typ: "); 
    if (lights[kolko].type==AMBIENT) s+=QString("ambient");
    if (lights[kolko].type==POINT)   s+=QString("point");
    if (lights[kolko].type==SPOT)    s+=QString("spot");
    s+=QString("\n");
  int R,G,B;
  s+=QString("farba: ");
    lights[kolko].color.rgb(&R,&G,&B);
    s+=QString::number(R)+QString(" ")+QString::number(G)+QString(" ")+QString::number(B);
    s+=QString("\n");
  if (lights[kolko].type==AMBIENT) { lightPokec->setText(s); return; }
  s+=QString("poloha: ");
    s+=QString::number(lights[kolko].location[0],'g',2);
    s+=QString(" ");
    s+=QString::number(lights[kolko].location[1],'g',2);
    s+=QString(" ");
    s+=QString::number(lights[kolko].location[2],'g',2);
    s+=QString("\n");
  if (lights[kolko].type==POINT) { lightPokec->setText(s); return; }
  s+=QString("svieti na: ");
    s+=QString::number(lights[kolko].location[0]+lights[kolko].direction[0],'g',2);
    s+=QString(" ");
    s+=QString::number(lights[kolko].location[1]+lights[kolko].direction[1],'g',2);
    s+=QString(" ");
    s+=QString::number(lights[kolko].location[2]+lights[kolko].direction[2],'g',2);
    s+=QString("\n");
  s+=QString("uhol: ");
    s+=QString::number(lights[kolko].angle,'g',2);
    if (lights[kolko].falloff>lights[kolko].angle) {
      s+=QString(" (rozptyl. do ");
      s+=QString::number(lights[kolko].falloff,'g',2);
      s+=QString(")");
    }
    s+=QString("\n");
  lightPokec->setText(s);
}

void Controls::describeTriangleSLOT()
{
  QString s("");
  int kolko;
  if (triangleList->currentItem()==-1) return;
  sscanf(triangleList->currentText().latin1(),"Triangle %d",&kolko);
  
  for (int hh=0;hh<3;hh++) {
    s+=QString("vertex")+QString::number(hh)+QString(": ");
      s+=QString::number(triangles[kolko].vertex[hh][0],'g',2);
      s+=QString(" ");
      s+=QString::number(triangles[kolko].vertex[hh][1],'g',2);
      s+=QString(" ");
      s+=QString::number(triangles[kolko].vertex[hh][2],'g',2);
      s+=QString("\n");
  }
  int R,G,B;
  s+=QString("farba: ");
    triangles[kolko].diffuseColor.rgb(&R,&G,&B);
    s+=QString::number(R)+QString(" ")+QString::number(G)+QString(" ")+QString::number(B);
    s+=QString("\n");
  trianglePokec->setText(s);
}

void Controls::describeSphereSLOT()
{
  QString s("");
  int kolko;
  if (sphereList->currentItem()==-1) return;
  sscanf(sphereList->currentText().latin1(),"Sphere %d",&kolko);
  
  s+=QString("stred: ");
    s+=QString::number(spheres[kolko].center[0],'g',2);
    s+=QString(" ");
    s+=QString::number(spheres[kolko].center[1],'g',2);
    s+=QString(" ");
    s+=QString::number(spheres[kolko].center[2],'g',2);
    s+=QString("\n");
  s+=QString("polomer: ");
    s+=QString::number(spheres[kolko].radius,'g',2);
    s+=QString("\n");
  int R,G,B;
  s+=QString("farba: ");
    spheres[kolko].diffuseColor.rgb(&R,&G,&B);
    s+=QString::number(R)+QString(" ")+QString::number(G)+QString(" ")+QString::number(B);
    s+=QString("\n");
/*  s+=QString("pozera na: ");
    s+=QString::number(spheres[kolko].location[0]+spheres[kolko].direction[0],'g',2);
    s+=QString(" ");
    s+=QString::number(spheres[kolko].location[1]+spheres[kolko].direction[1],'g',2);
    s+=QString(" ");
    s+=QString::number(spheres[kolko].location[2]+spheres[kolko].direction[2],'g',2);
    s+=QString("\n");
  s+=QString("hore: ");
    s+=QString::number(spheres[kolko].up[0],'g',2);
    s+=QString(" ");
    s+=QString::number(spheres[kolko].up[1],'g',2);
    s+=QString(" ");
    s+=QString::number(spheres[kolko].up[2],'g',2);
    s+=QString("\n");*/
  spherePokec->setText(s);
}

int Controls::getIntVector(QString prompt, QString defaultny, int *first, int *second, int *third){
  bool ok;
  QString text = QInputDialog::getText("mfray-gui", prompt, QLineEdit::Normal, defaultny, &ok, this );
  if ( ok && !text.isEmpty() ) if (sscanf(text.latin1(),"%d %d %d",first,second,third)==3) return 1;
  return 0;
}

int Controls::getDouble(QString prompt, QString defaultny, double *first){
  bool ok;
  QString text = QInputDialog::getText("mfray-gui", prompt, QLineEdit::Normal, defaultny, &ok, this );
  if ( ok && !text.isEmpty() ) if (sscanf(text.latin1(),"%lf",first)==1) return 1;
  return 0;
}

int Controls::getDoubleVector(QString prompt, QString defaultny, double *first, double *second, double *third){
  bool ok;
  QString text = QInputDialog::getText("mfray-gui", prompt, QLineEdit::Normal, defaultny, &ok, this );
  if ( ok && !text.isEmpty() ) if (sscanf(text.latin1(),"%lf %lf %lf",first,second,third)==3) return 1;
  return 0;
}






























/////////////////////////////////////////////////////////////////////////////////
//                    load sceny
/////////////////////////////////////////////////////////////////////////////////

void Controls::LoadCamera(){
  char row[1000],*rest;
  int i,rl;
  tVector smer,perp;
  double pom;
 
  Kamera.location[0]=Kamera.location[1]=Kamera.location[2]=0; Kamera.location[3]=1;
  Kamera.direction[2]=1; Kamera.direction[0]=Kamera.direction[1]=Kamera.direction[3]=0;
  Kamera.right[0]=0.3*1.33333333; Kamera.right[1]=Kamera.right[2]=Kamera.right[3]=0;
  Kamera.up[1]=0.3*1; Kamera.up[0]=Kamera.up[2]=Kamera.up[3]=0;
  
  fgets(row,1000,f); fscanf(f," "); rl=strlen(row); while (row[rl-1]<=32) row[--rl]=0;
  while (strcmp(row,"end")) {
    while (1) { // trick, bude len raz, ale chceme vediet breakovat
      if ((row[0]=='/')&&(row[1]=='/')) break;
      rl=strlen(row); for (i=0;i<rl;i++) if (row[i]=='=') break;
      if (i==rl) { /* dbgmessage("Load: camera: I don't understand: '%s'\n",row); */ break; }
      rest=row+i+1; row[i]=0;
      if (!strcmp(row,"location")) {
        sscanf(rest,"%lf , %lf , %lf",&Kamera.location[0],&Kamera.location[1],&Kamera.location[2]);
        break;
      }
      if (!strcmp(row,"look_at")) {
        sscanf(rest,"%lf , %lf , %lf",&smer[0],&smer[1],&smer[2]); smer[3]=0;
        for (i=0;i<3;i++) { smer[i]-=Kamera.location[i]; Kamera.direction[i]=perp[i]=smer[i]; }
        perp[1]=0;
        if (Length(perp)<EPS){
          // pozerame hore alebo dole
        } else {
          pom=perp[0]; perp[0]=perp[2]; perp[2]=-pom; // note the minus sign!
          CrossProduct(smer,perp,&Kamera.up); Normalize(&Kamera.up);
          CrossProduct(Kamera.up,Kamera.direction,&Kamera.right);
          for (i=0;i<3;i++) { 
            Kamera.up[i]*=0.3*Length(Kamera.direction);
            Kamera.right[i]*=0.4*Length(Kamera.direction);
          }
        }
        break;
      }
      break; 
    }
    fgets(row,1000,f); fscanf(f," "); rl=strlen(row); while (row[rl-1]<=32) row[--rl]=0;
  }
}

void Controls::LoadSphere(){
  char row[1000],*rest;
  int i,rl;
  tVector pcolor;
  int R,G,B;
 
  // NASTAVIME DEFAULT HODNOTY FARBY A MATERIALU
  spheres[sphereCount].diffuseColor=QColor(white);
  spheres[sphereCount].reflection[AMBIENT]=0.15; 
  spheres[sphereCount].reflection[DIFFUSE]=0.8; 
  spheres[sphereCount].reflection[SPECULAR]=0.0; 
  spheres[sphereCount].transparency=0.0; 
  spheres[sphereCount].refractionindex=1.0; 
  spheres[sphereCount].reflectionexponent=30.0; 
  spheres[sphereCount].deleted=0; 
  sphereList->insertItem(QString::fromLatin1("Sphere ")+QString::number(sphereCount));
  
  fgets(row,1000,f); fscanf(f," "); rl=strlen(row); while (row[rl-1]<=32) row[--rl]=0;
  while (strcmp(row,"end")) {
    while (1) { // trick, bude len raz, ale chceme vediet breakovat
      if ((row[0]=='/')&&(row[1]=='/')) break;
      rl=strlen(row); for (i=0;i<rl;i++) if (row[i]=='=') break;
      if (i==rl) { /* dbgmessage("Load: sphere: I don't understand: '%s'\n",row); */ break; }
      rest=row+i+1; row[i]=0;
      if (!strcmp(row,"center")) {
        sscanf(rest,"%lf , %lf , %lf",
            &spheres[sphereCount].center[0],&spheres[sphereCount].center[1],&spheres[sphereCount].center[2]);
        break;
      }
      if (!strcmp(row,"color")) {
        sscanf(rest,"%lf , %lf , %lf",&pcolor[0],&pcolor[1],&pcolor[2]);
        R=(int)(pcolor[0]*255); G=(int)(pcolor[1]*255); B=(int)(pcolor[2]*255);
        spheres[sphereCount].diffuseColor=QColor(R,G,B);
        break;
      }
      if (!strcmp(row,"specular_color")) {
        sscanf(rest,"%lf , %lf , %lf",&pcolor[0],&pcolor[1],&pcolor[2]);
        R=(int)(pcolor[0]*255); G=(int)(pcolor[1]*255); B=(int)(pcolor[2]*255);
        spheres[sphereCount].specularColor=QColor(R,G,B);
        break;
      }
      if (!strcmp(row,"emissive_color")) {
        sscanf(rest,"%lf , %lf , %lf",&pcolor[0],&pcolor[1],&pcolor[2]);
        R=(int)(pcolor[0]*255); G=(int)(pcolor[1]*255); B=(int)(pcolor[2]*255);
        spheres[sphereCount].emissiveColor=QColor(R,G,B);
        break;
      }
      if (!strcmp(row,"reflection")) {
        sscanf(rest,"%lf , %lf , %lf",&spheres[sphereCount].reflection[0],
            &spheres[sphereCount].reflection[1],&spheres[sphereCount].reflection[2]);
        break;
      }
      if (!strcmp(row,"refraction_index")) { sscanf(rest,"%lf",&spheres[sphereCount].refractionindex); break; }
      if (!strcmp(row,"radius")) { sscanf(rest,"%lf",&spheres[sphereCount].radius); break; }
      if (!strcmp(row,"transparency")) { sscanf(rest,"%lf",&spheres[sphereCount].transparency); break; }
      if (!strcmp(row,"reflection_exponent")) { sscanf(rest,"%lf",&spheres[sphereCount].reflectionexponent); break; }
      break; 
    }
    fgets(row,1000,f); fscanf(f," "); rl=strlen(row); while (row[rl-1]<=32) row[--rl]=0;
  }
  sphereCount++;
}

void Controls::LoadTriangle(){
  char row[1000],*rest;
  int i,rl,v,ma_normaly=0;
  tVector v1,v2;
  tVector pcolor;
  int R,G,B;
 
  // NASTAVIME DEFAULT HODNOTY FARBY A MATERIALU
  triangles[triangleCount].diffuseColor=QColor(white);
  triangles[triangleCount].reflection[AMBIENT]=0.15; 
  triangles[triangleCount].reflection[DIFFUSE]=0.8; 
  triangles[triangleCount].reflection[SPECULAR]=0.0; 
  triangles[triangleCount].transparency=0.0; 
  triangles[triangleCount].refractionindex=1.0; 
  triangles[triangleCount].reflectionexponent=30.0; 
  triangles[triangleCount].deleted=0; 
  triangleList->insertItem(QString::fromLatin1("Triangle ")+QString::number(triangleCount));
  
  fgets(row,1000,f); fscanf(f," "); rl=strlen(row); while (row[rl-1]<=32) row[--rl]=0;
  while (strcmp(row,"end")) {
    while (1) { // trick, bude len raz, ale chceme vediet breakovat
      if ((row[0]=='/')&&(row[1]=='/')) break;
      rl=strlen(row); for (i=0;i<rl;i++) if (row[i]=='=') break;
      if (i==rl) { /* dbgmessage("Load: triangle: I don't understand: '%s'\n",row); */ break; }
      rest=row+i+1; row[i]=0;
      if (sscanf(row,"vertex%d",&v)) {
        sscanf(rest,"%lf , %lf , %lf",&triangles[triangleCount].vertex[v][0],
            &triangles[triangleCount].vertex[v][1],&triangles[triangleCount].vertex[v][2]);
        break;
      }
      if (sscanf(row,"normal%d",&v)) {
        sscanf(rest,"%lf , %lf , %lf",&triangles[triangleCount].normal[v][0],
            &triangles[triangleCount].normal[v][1],&triangles[triangleCount].normal[v][2]);
        ma_normaly=1;
        break;
      }
      if (!strcmp(row,"color")) {
        sscanf(rest,"%lf , %lf , %lf",&pcolor[0],&pcolor[1],&pcolor[2]);
        R=(int)(pcolor[0]*255); G=(int)(pcolor[1]*255); B=(int)(pcolor[2]*255);
        triangles[triangleCount].diffuseColor=QColor(R,G,B);
        break;
      }
      if (!strcmp(row,"specular_color")) {
        sscanf(rest,"%lf , %lf , %lf",&pcolor[0],&pcolor[1],&pcolor[2]);
        R=(int)(pcolor[0]*255); G=(int)(pcolor[1]*255); B=(int)(pcolor[2]*255);
        triangles[triangleCount].specularColor=QColor(R,G,B);
        break;
      }
      if (!strcmp(row,"emissive_color")) {
        sscanf(rest,"%lf , %lf , %lf",&pcolor[0],&pcolor[1],&pcolor[2]);
        R=(int)(pcolor[0]*255); G=(int)(pcolor[1]*255); B=(int)(pcolor[2]*255);
        triangles[triangleCount].emissiveColor=QColor(R,G,B);
        break;
      }
      if (!strcmp(row,"reflection")) {
        sscanf(rest,"%lf , %lf , %lf",&triangles[triangleCount].reflection[0],
            &triangles[triangleCount].reflection[1],&triangles[triangleCount].reflection[2]);
        break;
      }
      if (!strcmp(row,"refraction_index")) { sscanf(rest,"%lf",&triangles[triangleCount].refractionindex); break; }
      if (!strcmp(row,"transparency")) {
        sscanf(rest,"%lf",&triangles[triangleCount].transparency);
        break;
      }
      if (!strcmp(row,"reflection_exponent")) {
        sscanf(rest,"%lf",&triangles[triangleCount].reflectionexponent);
        break;
      }
      break; 
    }
    fgets(row,1000,f); fscanf(f," "); rl=strlen(row); while (row[rl-1]<=32) row[--rl]=0;
  }
  if (!ma_normaly){
    for (i=0;i<3;i++) { 
      v1[i]=triangles[triangleCount].vertex[1][i]-triangles[triangleCount].vertex[0][i];
      v2[i]=triangles[triangleCount].vertex[2][i]-triangles[triangleCount].vertex[0][i];
    }
    for (i=0;i<3;i++) {
      CrossProduct(v2,v1,&triangles[triangleCount].normal[i]);
      Normalize(&triangles[triangleCount].normal[i]);
    }
  }
  triangleCount++;
}

void Controls::LoadAmbientLight(){
  char row[1000],*rest;
  int i,rl;
  tVector AmbientLight;
  int R,G,B;
  
  lights[lightCount].type=AMBIENT;
  lights[lightCount].color=QColor("white");
  lights[lightCount].deleted=0;
  lightList->insertItem(QString::fromLatin1("Light ")+QString::number(lightCount)+QString::fromLatin1(" (ambient)"),10+i);
  
  fgets(row,1000,f); fscanf(f," "); rl=strlen(row); while (row[rl-1]<=32) row[--rl]=0;
  while (strcmp(row,"end")) {
    while (1) { // trick, bude len raz, ale chceme vediet breakovat
      if ((row[0]=='/')&&(row[1]=='/')) break;
      rl=strlen(row); for (i=0;i<rl;i++) if (row[i]=='=') break;
      if (i==rl) { /* dbgmessage("Load: sphere: I don't understand: '%s'\n",row); */ break; }
      rest=row+i+1; row[i]=0;
      
      if (!strcmp(row,"color")) {
        sscanf(rest,"%lf , %lf , %lf",&AmbientLight[0],&AmbientLight[1],&AmbientLight[2]);
//        dbgmessage("Load: ambient_light_src: color %.2f %.2f %.2f\n",AmbientLight[0],AmbientLight[1],AmbientLight[2]);
        R=(int)(AmbientLight[0]*255); G=(int)(AmbientLight[1]*255); B=(int)(AmbientLight[2]*255);
        lights[lightCount].color=QColor(R,G,B);
        break;
      }
      
//      dbgmessage("Load: ambient_light_source: Not implemented: '%s'\n",row);
      break; 
    }
    fgets(row,1000,f); fscanf(f," "); rl=strlen(row); while (row[rl-1]<=32) row[--rl]=0;
  }
  lightCount++;
}

void Controls::LoadPointLight(){
  char row[1000],*rest;
  int i,rl;
  tVector pcolor;
  int R,G,B;
  
  lights[lightCount].type=POINT;
  lights[lightCount].color=QColor("white");
  for (i=0;i<3;i++) lights[lightCount].location[i]=0; 
  lights[lightCount].deleted=0;
  lightList->insertItem(QString::fromLatin1("Light ")+QString::number(lightCount)+QString::fromLatin1(" (point)"),i);
  
  fgets(row,1000,f); fscanf(f," "); rl=strlen(row); while (row[rl-1]<=32) row[--rl]=0;
  while (strcmp(row,"end")) {
    while (1) { // trick, bude len raz, ale chceme vediet breakovat
      if ((row[0]=='/')&&(row[1]=='/')) break;
      rl=strlen(row); for (i=0;i<rl;i++) if (row[i]=='=') break;
      if (i==rl) { /*dbgmessage("Load: point_light_source: I don't understand: '%s'\n",row); */ break; }
      rest=row+i+1; row[i]=0;
      if (!strcmp(row,"location")) {
        sscanf(rest,"%lf , %lf , %lf",
            &lights[lightCount].location[0],&lights[lightCount].location[1],&lights[lightCount].location[2]);
        break;
      }
      if (!strcmp(row,"color")) {
        sscanf(rest,"%lf , %lf , %lf",&pcolor[0],&pcolor[1],&pcolor[2]);
        R=(int)(pcolor[0]*255); G=(int)(pcolor[1]*255); B=(int)(pcolor[2]*255);
        lights[lightCount].color=QColor(R,G,B);
        break;
      }
      if (!strcmp(row,"attenuation")) {
        sscanf(rest,"%lf , %lf , %lf",
            &lights[lightCount].attenuation[0],
            &lights[lightCount].attenuation[1],
            &lights[lightCount].attenuation[2]);
        break;
      }
      break; 
    }
    fgets(row,1000,f); fscanf(f," "); rl=strlen(row); while (row[rl-1]<=32) row[--rl]=0;
  }
  lightCount++;
}

void Controls::LoadSpotLight(){
  char row[1000],*rest;
  int i,rl;
  tVector pcolor;
  int R,G,B;
  double tmp;
  
  lights[lightCount].type=SPOT;
  lights[lightCount].color=QColor("white");
  for (i=0;i<3;i++) { lights[lightCount].location[i]=0; lights[lightCount].direction[i]=i; }
  lights[lightCount].angle=30;
  lights[lightCount].falloff=50;
  lights[lightCount].deleted=0;
  lightList->insertItem(QString::fromLatin1("Light ")+QString::number(lightCount)+QString::fromLatin1(" (spot)"),i);
  
  fgets(row,1000,f); fscanf(f," "); rl=strlen(row); while (row[rl-1]<=32) row[--rl]=0;
  while (strcmp(row,"end")) {
    while (1) { // trick, bude len raz, ale chceme vediet breakovat
      if ((row[0]=='/')&&(row[1]=='/')) break;
      rl=strlen(row); for (i=0;i<rl;i++) if (row[i]=='=') break;
      if (i==rl) { /*dbgmessage("Load: point_light_source: I don't understand: '%s'\n",row); */ break; }
      rest=row+i+1; row[i]=0;
      if (!strcmp(row,"location")) {
        sscanf(rest,"%lf , %lf , %lf",
            &lights[lightCount].location[0],&lights[lightCount].location[1],&lights[lightCount].location[2]);
        break;
      }
      if (!strcmp(row,"color")) {
        sscanf(rest,"%lf , %lf , %lf",&pcolor[0],&pcolor[1],&pcolor[2]);
        R=(int)(pcolor[0]*255); G=(int)(pcolor[1]*255); B=(int)(pcolor[2]*255);
        lights[lightCount].color=QColor(R,G,B);
        break;
      }
      if (!strcmp(row,"look_at")) {
        sscanf(rest,"%lf , %lf , %lf",
            &lights[lightCount].direction[0],&lights[lightCount].direction[1],&lights[lightCount].direction[2]);
        for (i=0;i<3;i++) lights[lightCount].direction[i]-=lights[lightCount].location[i];
        break;
      }
      if (!strcmp(row,"attenuation")) {
        sscanf(rest,"%lf , %lf , %lf",
            &lights[lightCount].attenuation[0],
            &lights[lightCount].attenuation[1],
            &lights[lightCount].attenuation[2]);
        break;
      }
      if (!strcmp(row,"angle")) {sscanf(rest,"%lf",&tmp);lights[lightCount].angle=lights[lightCount].falloff=tmp;break;}
      if (!strcmp(row,"falloff")) { sscanf(rest,"%lf",&tmp); lights[lightCount].falloff=tmp; break; }
      break; 
    }
    fgets(row,1000,f); fscanf(f," "); rl=strlen(row); while (row[rl-1]<=32) row[--rl]=0;
  }
  lightCount++;
}

int Controls::LoadScene(QString infilename){
  int rl;
  char row[1000];
  
  if (!(f=fopen(infilename.latin1(),"r"))) { printf("Open failed.\n"); return 0; }

  // vyprazdnime pamat
  lightCount=triangleCount=sphereCount=0;
  lightList->clear(); triangleList->clear(); sphereList->clear();
  lightPokec->setText(QString("Tu bude pokec\no svetle"));
  trianglePokec->setText(QString("Tu bude pokec\no trojuholniku"));
  spherePokec->setText(QString("Tu bude pokec\no guli"));

  while (!feof(f)){
    fgets(row,1000,f); fscanf(f," "); rl=strlen(row); while (row[rl-1]<=32) row[--rl]=0;
//    dbgmessage("Debug: loaded '%s'\n",row);
    if (rl==0) continue;
    if ((row[0]=='/')&&(row[1]=='/')) continue;
    if (!strcmp(row,"camera")) { LoadCamera(); continue; }
    if (!strcmp(row,"sphere")) { LoadSphere(); continue; }
    if (!strcmp(row,"triangle")) { LoadTriangle(); continue; }
    if (!strcmp(row,"ambient_light_source")) { LoadAmbientLight(); continue; }
    if (!strcmp(row,"point_light_source")) { LoadPointLight(); continue; }
    if (!strcmp(row,"spot_light_source")) { LoadSpotLight(); continue; }
    if (!strcmp(row,"eof")) break; 
//    dbgmessage("Load: I don't understand: '%s'\n",row);
  }
  fclose(f);

  return 1;
}

int Controls::SaveScene(QString infilename){
  int R,G,B;
  
  if (!(f=fopen(infilename.latin1(),"w"))) { printf("Open failed.\n"); return 0; }

  // hlavicka
  fprintf(f,"//\n// created by mfray-gui\n//\n\n");
  // kamera
  fprintf(f,"//\n// kamera\n//\n\n");
  fprintf(f,"camera\n");
  // FIXME
  // fprintf(f,"location=-10, 5, 7\nlook_at=-9, 4.9, 7.4\n");
  fprintf(f,"location=%.5f, %.5f, %.5f\n",Kamera.location[0],Kamera.location[1],Kamera.location[2]);
  fprintf(f,"look_at=%.5f, %.5f, %.5f\n",
      Kamera.location[0]+Kamera.direction[0],Kamera.location[1]+Kamera.direction[1],
      Kamera.location[2]+Kamera.direction[2]);
  fprintf(f,"up=%.5f, %.5f, %.5f\n",Kamera.up[0],Kamera.up[1],Kamera.up[2]);
  fprintf(f,"end\n\n");
  // svetla
  for (int i=0;i<lightCount;i++) if (!lights[i].deleted) {
    fprintf(f,"//\n// svetlo %d\n//\n\n",i);
    switch (lights[i].type) {
      case AMBIENT:
        fprintf(f,"ambient_light_source\n");
        lights[i].color.rgb(&R,&G,&B); fprintf(f,"color=%.5f, %.5f, %.5f\n",R/255.0,G/255.0,B/255.0);
        fprintf(f,"end\n\n");
        break;
      case POINT:
        fprintf(f,"point_light_source\n");
        lights[i].color.rgb(&R,&G,&B); fprintf(f,"color=%.5f, %.5f, %.5f\n",R/255.0,G/255.0,B/255.0);
        fprintf(f,"location=%.5f, %.5f, %.5f\n",lights[i].location[0],lights[i].location[1],lights[i].location[2]);
        fprintf(f,"attenuation=%.5f, %.5f, %.5f\n",
            lights[i].attenuation[0],lights[i].attenuation[1],lights[i].attenuation[2]);
        fprintf(f,"end\n\n");
        break;
      case SPOT:
        fprintf(f,"spot_light_source\n");
        lights[i].color.rgb(&R,&G,&B); fprintf(f,"color=%.5f, %.5f, %.5f\n",R/255.0,G/255.0,B/255.0);
        fprintf(f,"location=%.5f, %.5f, %.5f\n",lights[i].location[0],lights[i].location[1],lights[i].location[2]);
        fprintf(f,"look_at=%.5f, %.5f, %.5f\n",lights[i].location[0]+lights[i].direction[0],
            lights[i].location[1]+lights[i].direction[1],lights[i].location[2]+lights[i].direction[2]);
        fprintf(f,"attenuation=%.5f, %.5f, %.5f\n",
            lights[i].attenuation[0],lights[i].attenuation[1],lights[i].attenuation[2]);
        fprintf(f,"angle=%.5f\n",lights[i].angle);
        if (lights[i].falloff>lights[i].angle) fprintf(f,"falloff=%.5f\n",lights[i].falloff);
        fprintf(f,"end\n\n");
        break;
    }
  }
  // trojuholniky
  for (int i=0;i<triangleCount;i++) if (!triangles[i].deleted) {
    fprintf(f,"//\n// trojuholnik %d\n//\n\n",i);
    fprintf(f,"triangle\n");
    for (int j=0;j<3;j++) 
      fprintf(f,"vertex%d=%.5f, %.5f, %.5f\n",j,
        triangles[i].vertex[j][0],triangles[i].vertex[j][1],triangles[i].vertex[j][2]);
    for (int j=0;j<3;j++) 
      fprintf(f,"normal%d=%.5f, %.5f, %.5f\n",j,
        triangles[i].normal[j][0],triangles[i].normal[j][1],triangles[i].normal[j][2]);
    triangles[i].diffuseColor.rgb(&R,&G,&B); fprintf(f,"color=%.5f, %.5f, %.5f\n",R/255.0,G/255.0,B/255.0);
    triangles[i].specularColor.rgb(&R,&G,&B); fprintf(f,"specular_color=%.5f, %.5f, %.5f\n",R/255.0,G/255.0,B/255.0);
    triangles[i].emissiveColor.rgb(&R,&G,&B); fprintf(f,"emissive_color=%.5f, %.5f, %.5f\n",R/255.0,G/255.0,B/255.0);
    fprintf(f,"reflection=%.5f, %.5f, %.5f\n",
      triangles[i].reflection[0],triangles[i].reflection[1],triangles[i].reflection[2]);
    if (triangles[i].refractionindex>1+EPS) fprintf(f,"refraction_index=%.5f\n",triangles[i].refractionindex);
    fprintf(f,"reflection_exponent=%.5f\n",triangles[i].reflectionexponent);
    if (triangles[i].transparency>EPS) fprintf(f,"transparency=%.5f\n",triangles[i].transparency);
    fprintf(f,"end\n\n");
  }
  // gule
  for (int i=0;i<sphereCount;i++) if (!spheres[i].deleted) {
    fprintf(f,"//\n// gula %d\n//\n\n",i);
    fprintf(f,"sphere\n");
    fprintf(f,"center=%.5f, %.5f, %.5f\n",spheres[i].center[0],spheres[i].center[1],spheres[i].center[2]);
    fprintf(f,"radius=%.5f\n",spheres[i].radius);
    spheres[i].diffuseColor.rgb(&R,&G,&B); fprintf(f,"color=%.5f, %.5f, %.5f\n",R/255.0,G/255.0,B/255.0);
    spheres[i].specularColor.rgb(&R,&G,&B); fprintf(f,"specular_color=%.5f, %.5f, %.5f\n",R/255.0,G/255.0,B/255.0);
    spheres[i].emissiveColor.rgb(&R,&G,&B); fprintf(f,"emissive_color=%.5f, %.5f, %.5f\n",R/255.0,G/255.0,B/255.0);
    fprintf(f,"reflection=%.5f, %.5f, %.5f\n",
      spheres[i].reflection[0],spheres[i].reflection[1],spheres[i].reflection[2]);
    if (spheres[i].refractionindex>1+EPS) fprintf(f,"refraction_index=%.5f\n",spheres[i].refractionindex);
    fprintf(f,"reflection_exponent=%.5f\n",spheres[i].reflectionexponent);
    if (spheres[i].transparency>EPS) fprintf(f,"transparency=%.5f\n",spheres[i].transparency);
    fprintf(f,"end\n\n");
  }
  
  fprintf(f,"eof\n\n47 is here ;)\n");
  fclose(f);

  return 1;
}

void Controls::loadSceneSLOT() {
  QString s = QFileDialog::getOpenFileName(".","my scene files (*.scene)",this,"open file dialog","Choose a file");
  if (s.isNull()) return;
  currentFileName=QString("");
  if (!LoadScene(s)) printf("Failed to load %s!\n",s.latin1()); else { 
    currentFileName=s; 
    emit repaintSIGNAL(); 
    describeLightSLOT();
    describeCameraSLOT();
  }
}

void Controls::loadVRMLSLOT() {
  QString s = QFileDialog::getOpenFileName(".","VRML files (*.wrl *.vrml)",this,"open file dialog","Choose a file");
  if (s.isNull()) return;
  currentFileName=QString("");
  QString s2=QString("/tmp/vrml.scene");
  
  char *haluz[2]; haluz[0]=(char*)malloc(100); strcpy(haluz[0],"LD_LIBRARY_PATH=./vrml2scene"); haluz[1]=NULL;
  
  if (fork()==0) { execle("vrml2scene/vrml2scene","RUN",s.latin1(),s2.latin1(),NULL,haluz); } else wait(NULL);
  if (!LoadScene(s2)) printf("Failed to load %s!\n",s2.latin1()); else { 
    currentFileName=s2; 
    emit repaintSIGNAL(); 
    describeLightSLOT();
    describeCameraSLOT();
  }
}

void Controls::saveSceneSLOT() {
  QString s = QFileDialog::getSaveFileName(currentFileName,"my scene files (*.scene)",this,"save","Choose a file");
  if (s.isNull()) return;
  if (!SaveScene(s)) printf("Failed to save %s!\n",s.latin1()); else currentFileName=s;
}

PleaseWait::PleaseWait( QWidget* parent, const char* name) : QWidget( parent, name )
{
  QGridLayout *mainGrid = new QGridLayout(this,1,1,10);
  QLabel *ml=new QLabel("<b>Pockajte na koniec raytracovania...</b>",this);
  mainGrid->addWidget(ml,0,0);
}

PleaseWait::~PleaseWait()
{
}

