#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include "trivrml.h"

tri_VRML vrml;
tri_Scene scene;

int main(int argc, char **argv){
    int i,j,k,obj;
    char name[100],name2[100];
    double q[4];
    tri_Material m;
    FILE *g;

    strncpy(name,argv[1],sizeof(name));
    strncpy(name2,argv[2],sizeof(name2));
    if ((!strcmp(name2,""))||(argc>3)) { fprintf(stderr,"Usage: %s <file.wrl> <file.scene>\n",argv[0]); return -1; }
    
    // load vrml
    vrml=tri_Open(name);
    tri_SetDivisions(vrml,16,8,8);
    scene=tri_Convert(vrml);
    tri_Close(vrml);

    printf("loaded\n");

    fprintf(stderr,"vstup: %s\nvystup: %s\n",name,name2);
    
    g=fopen(name2,"w");

    // vypis kameru
    fprintf(g,"//\n// %s\n//\n\n","camera");
    fprintf(g,"camera\n");
    fprintf(g,"location=%g, %g, %g\n",scene.Camera.Pos[0],scene.Camera.Pos[1],scene.Camera.Pos[2]);
    fprintf(g,"look_at=%g, %g, %g\n",
		      scene.Camera.Pos[0]+scene.Camera.Dir[0],
                      scene.Camera.Pos[1]+scene.Camera.Dir[1],
                      scene.Camera.Pos[2]+scene.Camera.Dir[2]);
    // FIXME up
    fprintf(g,"end\n\n");
  
    // vypis svetla
    fprintf(g,"//\n// %s\n//\n\n","svetla");
    fprintf(g,"ambient_light_source\ncolor=1, 1, 1\nend\n\n");
    
    for (i=0;i<scene.nLights;i++){
      if (scene.Light[i].type==0) continue;
      if (scene.Light[i].type==1) fprintf(g,"point_light_source\n");
      if (scene.Light[i].type==2) fprintf(g,"spot_light_source\n");
      // FIXME ambient zlozku svetla ignorujeme
      for (j=0;j<3;j++) q[j]=scene.Light[i].intensity*scene.Light[i].color[j]; q[3]=1.0;
      fprintf(g,"color=%g, %g, %g\n",q[0],q[1],q[2]);
      
      switch (scene.Light[i].type){
        case 0: // directional
          // FIXME ignorujeme
          break;
        case 1: // point
          for (j=0;j<3;j++) q[j]=scene.Light[i].pos[j]; q[4]=1.0;
          fprintf(g,"location=%g, %g, %g\n",q[0],q[1],q[2]);
          fprintf(g,"attenuation=%g, %g, %g\n",scene.Light[i].attn[0],scene.Light[i].attn[1],scene.Light[i].attn[2]);
          break;
        case 2: // spot
          for (j=0;j<3;j++) q[j]=scene.Light[i].pos[j]; q[4]=1.0;
          fprintf(g,"location=%g, %g, %g\n",q[0],q[1],q[2]);
          for (j=0;j<3;j++) q[j]+=scene.Light[i].dir[j]; q[4]=1.0;
          fprintf(g,"look_at=%g, %g, %g\n",q[0],q[1],q[2]);
          fprintf(g,"angle=%g\n",scene.Light[i].cutOffAngle);
          fprintf(g,"attenuation=%g, %g, %g\n",scene.Light[i].attn[0],scene.Light[i].attn[1],scene.Light[i].attn[2]);
          break;
      }
      fprintf(g,"end\n\n");
    }

    // vypis objekty
    fprintf(g,"//\n// %s\n//\n\n","objekty");
    for (obj=0;obj<scene.nObjects;obj++){
      m=scene.Object[obj].Material;
      
      for (i=0;i<scene.Object[obj].nTriangles;i++){
        fprintf(g,"triangle\n");
        for (k=0;k<3;k++){
          fprintf(g,"vertex%d=%g, %g, %g\n",k,
              scene.Object[obj].Triangle[i][k].x, 
              scene.Object[obj].Triangle[i][k].y, 
              scene.Object[obj].Triangle[i][k].z);
          fprintf(g,"normal%d=%g, %g, %g\n",k,
              scene.Object[obj].Triangle[i][k].nx, 
              scene.Object[obj].Triangle[i][k].ny, 
              scene.Object[obj].Triangle[i][k].nz);
        }
        fprintf(g,"reflection=%g, %g, %g\n",m.ambientIntensity,0.0,0.0);
        fprintf(g,"reflection_exponent=%g\n",m.shininess*128);
        fprintf(g,"color=%g, %g, %g\n",
              m.diffuseColor[0],m.diffuseColor[1],m.diffuseColor[2]);
        fprintf(g,"specular_color=%g, %g, %g\n",
              m.specularColor[0],m.specularColor[1],m.specularColor[2]);
        fprintf(g,"emissive_color=%g, %g, %g\n",
              m.emissiveColor[0],m.emissiveColor[1],m.emissiveColor[2]);
        fprintf(g,"end\n\n");
      }
    }
    fclose(g); 
    return 0;
}
